package visualization3;

/**
 * 最短距離法に基づく距離関数の実装です。
 */

public class NearestDistanceEvaluator implements DistanceEvaluator {
    public double distance(Node n1, Node n2) {
        double minDistSq = Double.MAX_VALUE;
        for (MultiVector v1 : n1.getVectors()) {
            for (MultiVector v2 : n2.getVectors()) {
                // 全てのベクトルの組み合わせに対して距離を計算
                double distSq = v1.distanceSq(v2);
                // 最小となる距離を採用
                if (distSq < minDistSq) {
                    minDistSq = distSq;
                }
            }
        }
        return Math.sqrt(minDistSq);
    }
}
